HUGO-SERVER(1)

NAME

hugo-server - A high performance webserver

SYNOPSIS

hugo server [flags]

DESCRIPTION

Hugo provides its own webserver which builds and serves the site. While hugo server is high performance, it is a webserver with limited options. Many run it in production, but the standard behavior is for people to use it in development and use a more full featured server such as Nginx or Caddy.

'hugo server' will avoid writing the rendered and served content to disk, preferring to store it in memory.

By default hugo will also watch your files for any changes you make and automatically rebuild the site. It will then live reload any open browser pages and push the latest content to them. As most Hugo sites are built in a fraction of a second, you will be able to save and see your changes nearly instantly.

OPTIONS

--appendPort[=true]
    append port to baseURL

-b, --baseURL=""
    hostname (and path) to the root, e.g. ⟨http://spf13.com/⟩

--bind="127.0.0.1"
    interface to which the server will bind

-D, --buildDrafts[=false]
    include content marked as draft

-E, --buildExpired[=false]
    include expired content

-F, --buildFuture[=false]
    include content with publishdate in the future

--cacheDir=""
    filesystem path to cache directory. Defaults: $TMPDIR/hugo_cache/

--cleanDestinationDir[=false]
    remove files from destination not found in static directories

-c, --contentDir=""
    filesystem path to content directory

-d, --destination=""
    filesystem path to write files to

--disableBrowserError[=false]
    do not show build errors in the browser

--disableFastRender[=false]
    enables full re-renders on changes

--disableKinds=[]
    disable different kind of pages (home, RSS etc.)

--disableLiveReload[=false]
    watch without enabling live browser reload on rebuild

--enableGitInfo[=false]
    add Git revision, date and author info to the pages

-e, --environment=""
    build environment

--forceSyncStatic[=false]
    copy all files when static is changed.

--gc[=false]
    enable to run some cleanup tasks (remove unused cache files) after the build

-h, --help[=false]
    help for server

--i18n-warnings[=false]
    print missing translations

--ignoreCache[=false]
    ignores the cache directory

-l, --layoutDir=""
    filesystem path to layout directory

--liveReloadPort=-1
    port for live reloading (i.e. 443 in HTTPS proxy situations)

--meminterval="100ms"
    interval to poll memory usage (requires --memstats), valid time units are "ns", "us" (or "µs"), "ms", "s", "m", "h".

--memstats=""
    log memory usage to this file

--minify[=false]
    minify any supported output format (HTML, XML etc.)

--navigateToChanged[=false]
    navigate to changed content file on live browser reload

--noChmod[=false]
    don't sync permission mode of files

--noHTTPCache[=false]
    prevent HTTP caching

--noTimes[=false]
    don't sync modification time of files

-p, --port=1313
    port on which the server will listen

--renderToDisk[=false]
    render to Destination path (default is render to memory serve from there)

-s, --source=""
    filesystem path to read files relative from

--stepAnalysis[=false]
    display memory and timing of different steps of the program

--templateMetrics[=false]
    display metrics about template executions

--templateMetricsHints[=false]
    calculate some improvement hints when combined with --templateMetrics

-t, --theme=[]
    themes to use (located in /themes/THEMENAME/)

--themesDir=""
    filesystem path to themes directory

-w, --watch[=true]
    watch filesystem for changes and recreate as needed

OPTIONS INHERITED FROM PARENT COMMANDS

--config=""
    config file (default is path/config.yaml|json|toml)

--configDir="config"
    config dir

--debug[=false]
    debug output

--log[=false]
    enable Logging

--logFile=""
    log File path (if set, logging enabled automatically)

--quiet[=false]
    build in quiet mode

-v, --verbose[=false]
    verbose output

--verboseLog[=false]
    verbose logging

SEE ALSO

hugo(1)